/*
 * Copyright 1991, 1992, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include "is_types.h"

#ifdef BSD
#define memcpy(a, b, c) bcopy((b), (a), (c))
#endif /* BSD */

#ifndef lint
static	char	sccsid[] = "@(#)is_key.c	1.4	11:48:58	1/29/92";
#endif

extern	int	db_errno;

int
__isam_buf2key (file, index, data, record, key)
file_t	*file;
int	index;
char	*data;
off_t	record;
char	*key;
{
	char	*cp = key;
	int	i, j;
	sort_key_t *sort_key = &file->f_index->i_keys[index];
	field_t	*fields = file->f_schema->s_fields,
		*field;

	for (i = 0;i < sort_key->k_field_count;i++) {
		if (! sort_key->k_unique &&
				i == (sort_key->k_field_count - 1)) {
			memcpy (cp, (char *) &record, sizeof (off_t));
			cp += sizeof (off_t);
		} else {
			field = &fields[sort_key->k_fields[i] & ~ IS_DESCENDING];
			memcpy (cp, data + field->f_offset, field->f_size);
			cp += field->f_size;
		}
	}
	return cp - key;
}

int
isam_get_key (file, buffer)
file_t	*file;
char	*buffer;
{
	keyblk_t *kb = (keyblk_t *) file->f_key_buffer;
	sort_key_t *key;
	char	*keyp;

	if (file->f_current_index <= 0 || file->f_current_index >=
			file->f_index->i_key_count)
		return (db_errno = DB_NO_INDEX), -1;

	if (file->f_key_slot < 0 || file->f_key_block == 0)
		return (db_errno = DB_INVALID), -1;

	key = file->f_index->i_keys + file->f_current_index;
	keyp = kb->kb_data + (file->f_key_slot * key->k_key_size);
	memcpy (buffer, keyp, key->k_key_size);

	return 0;
}
