#!/bin/sh
#
# Driver for test programs
#
#	@(#)test.sh	1.4	12:32:06	2/21/92
#
# Set these variables to the compiler flags and loader flags you wish to
# use.  C programs will be compiled as
#
#	cc -o test_?? $CCFLAGS test_??.c $LDFLAGS
#
CCFLAGS=
LDFLAGS=
export CCFLAGS LDFLAGS
#
for TEST in test_??.sh ; do
	TESTCASE=`expr $TEST : 'test_\([0-9]*\).sh'`
	if sh -${-} $TEST ; then
		echo Test $TESTCASE Passes
	else
		echo Test $TESTCASE Fails
		FAILED="$FAILED $TESTCASE"
	fi
done
if [ -z "$FAILED" ]; then
	exit 0
else
	echo Failing testcases: $FAILED
	exit 1
fi
